////////////////////////////////////////////////////////////
//
// File: drawtools.cpp
// Author: Sven Goossens
// Purpose:
//      Extending the dlist and item classes to provide a set of 'drawtools'
//      Contains an implementation of the pixel class, and skeleton for the
//      Line class
//
///////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include "glut.h"
#include "drawtools.h"

// class definitions:

     ///////////////////////////////////////////////////////
    //
   //  pixel class.
  //
 ///////////////////////////////////////////////////////
/*
      Please note that the pixel class is an incredibly inefficient way to draw
      1(!!) pixel to the screen. This class is mearly ment as an example of
      how to use the DrawList. 
*/
pixel::pixel(dlist* list, const float p[2], const float color[3])
	: item(list)    // call the ctor of item and chain into list
{
	assert(p);   // if you crash here then you called this with no coordinates
	_p[0] = p[0];// Store location of the pixel in the member variable _p
	_p[1] = p[1];

	if(!color) {      // When a null pointer is passed to this function
		_color[0] = 0;// black is used
		_color[1] = 0;
		_color[2] = 0;
	}
	else {
		_color[0] = color[0];
		_color[1] = color[1];
		_color[2] = color[2];
	}
}
//---------------------------------------------------------------------------
//
// draw myself on the screen
//
void pixel::draw(void) const
{
	glBegin(GL_POINTS);            // Start drawing mode

	// If a color was passed to the function, set it
	glColor3f(_color[0],_color[1], _color[2]);
	glVertex2fv(this->_p);        // Draw the pixel at (_p[0], _p[1])

	glEnd();
}
//---------------------------------------------------------------------------
//
// Print myself in ELIF format
//
void pixel::print(void) const
{
	printf(".pixel %.0f %.0f %.5f %.5f %.5f\n", _p[0], _p[1], _color[0],
															_color[1], _color[2]);
}
//---------------------------------------------------------------------------
//
// destructor of a pixel
//
pixel::~pixel(void)
{

}
//---------------------------------------------------------------------------
     ///////////////////////////////////////////////////////
    //
   //  line class.
  //
 ///////////////////////////////////////////////////////
line::line(dlist* list, const float p1[2], const float p2[2],
                        const float color[3], const float lineWidth)
	: item(list)    // call the ctor of item and chain into list
{
	// To be implemented by you
	// Some hints:
	// Check the inputs p1, p2 and color for validity (note they are actually
															  // pointers)
	// Then store them as member variables

	assert(0);  // Remove after implementing
}
//---------------------------------------------------------------------------
//
// destructor of a line
//
line::~line(void)
{

}
//---------------------------------------------------------------------------
//
// Print myself in EDIF++ format
//
void line::print(void) const
{
	//TODO:  line::print(void), To be implemented by you
	assert(0);  // Remove after implementing
}
//---------------------------------------------------------------------------
//
// draw myself on the screen
//
void line::draw(void) const
{
	// TODO: line::draw(void), to be implemented by you
	// Aim for about 10 lines of code
	assert(0);  // Remove after implementing
}

     ///////////////////////////////////////////////////////
    //
   //  text class.
  //
 ///////////////////////////////////////////////////////

 // TODO: Implement the text class here
